Require Import connectives.
Require Import leibniz.
Require Import logic.
Require Import relations.
Parameter nat : Type.
Parameter O : nat.
Parameter S : nat -> nat.
Parameter filter_nat_type : forall (return_:Type), (nat -> return_) -> nat -> return_.
Axiom axiom_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), connectives.equal (return_type) (filter_nat_type (return_type) return_ O) (return_ O).
Definition eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ O) (return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((axiom_filter_nat_type_O) (return_type)) (return_)).
Definition sym_eq_filter_nat_type_O : forall return_type, forall (return_:(nat -> return_type)), leibniz.leibniz (return_type) (return_ O) (filter_nat_type (return_type) return_ O) := fun (return_type:Type) => fun (return_:nat -> return_type) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ O)) (return_ O)) (((eq_filter_nat_type_O) (return_type)) (return_)).
Axiom axiom_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)).
Definition eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
Definition sym_eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (return_ (S n)) (filter_nat_type (return_type) return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((eq_filter_nat_type_S) (return_type)) (return_)) (n)).
Axiom nat_ind : forall (Q:(nat -> Prop)), (Q O) -> (forall (x:nat), (Q x) -> Q (S x)) -> forall (x:nat), Q x.
Parameter le : nat -> nat -> Prop.
Axiom le_n : forall (n:nat), le n n.
Axiom le_S : forall (n:nat), forall (m:nat), (le n m) -> le n (S m).
Axiom le_ind : forall (n:nat), forall (Q:(nat -> Prop)), (Q n) -> (forall (m:nat), (le n m) -> (Q m) -> Q (S m)) -> forall (m:nat), (le n m) -> Q m.
Definition lt : nat -> nat -> Prop := fun (n:nat) => fun (m:nat) => le (S n) m.
Parameter plus : nat -> nat -> nat.
Parameter plus_body : nat -> nat -> nat.
Axiom axiom_plus : forall (n:nat), connectives.equal (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n).
Definition eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (plus n) (filter_nat_type (nat -> nat) plus_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((axiom_plus) (n)).
Definition sym_eq_plus : forall (n:nat), leibniz.leibniz (nat -> nat) (filter_nat_type (nat -> nat) plus_body n) (plus n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (plus n)) (filter_nat_type (nat -> nat) plus_body n)) ((eq_plus) (n)).
Axiom axiom_plus_body_O : connectives.equal (nat -> nat) (plus_body O) (fun (m:nat) => m).
Definition eq_plus_body_O : leibniz.leibniz (nat -> nat) (plus_body O) (fun (m:nat) => m) := ((((connectives.equal_leibniz) (nat -> nat)) (plus_body O)) (fun (m:nat) => m)) (axiom_plus_body_O).
Definition sym_eq_plus_body_O : leibniz.leibniz (nat -> nat) (fun (m:nat) => m) (plus_body O) := ((((leibniz.sym_leibniz) (nat -> nat)) (plus_body O)) (fun (m:nat) => m)) (eq_plus_body_O).
Axiom axiom_plus_body_S : forall (n:nat), connectives.equal (nat -> nat) (plus_body (S n)) (fun (m:nat) => S (plus n m)).
Definition eq_plus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (plus_body (S n)) (fun (m:nat) => S (plus n m)) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (plus_body (S n))) (fun (m:nat) => S (plus n m))) ((axiom_plus_body_S) (n)).
Definition sym_eq_plus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (fun (m:nat) => S (plus n m)) (plus_body (S n)) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (plus_body (S n))) (fun (m:nat) => S (plus n m))) ((eq_plus_body_S) (n)).
Parameter times : nat -> nat -> nat.
Parameter times_body : nat -> nat -> nat.
Axiom axiom_times : forall (n:nat), connectives.equal (nat -> nat) (times n) (filter_nat_type (nat -> nat) times_body n).
Definition eq_times : forall (n:nat), leibniz.leibniz (nat -> nat) (times n) (filter_nat_type (nat -> nat) times_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (times n)) (filter_nat_type (nat -> nat) times_body n)) ((axiom_times) (n)).
Definition sym_eq_times : forall (n:nat), leibniz.leibniz (nat -> nat) (filter_nat_type (nat -> nat) times_body n) (times n) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (times n)) (filter_nat_type (nat -> nat) times_body n)) ((eq_times) (n)).
Axiom axiom_times_body_O : connectives.equal (nat -> nat) (times_body O) (fun (m:nat) => O).
Definition eq_times_body_O : leibniz.leibniz (nat -> nat) (times_body O) (fun (m:nat) => O) := ((((connectives.equal_leibniz) (nat -> nat)) (times_body O)) (fun (m:nat) => O)) (axiom_times_body_O).
Definition sym_eq_times_body_O : leibniz.leibniz (nat -> nat) (fun (m:nat) => O) (times_body O) := ((((leibniz.sym_leibniz) (nat -> nat)) (times_body O)) (fun (m:nat) => O)) (eq_times_body_O).
Axiom axiom_times_body_S : forall (n:nat), connectives.equal (nat -> nat) (times_body (S n)) (fun (m:nat) => plus m (times n m)).
Definition eq_times_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (times_body (S n)) (fun (m:nat) => plus m (times n m)) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (times_body (S n))) (fun (m:nat) => plus m (times n m))) ((axiom_times_body_S) (n)).
Definition sym_eq_times_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (fun (m:nat) => plus m (times n m)) (times_body (S n)) := fun (n:nat) => ((((leibniz.sym_leibniz) (nat -> nat)) (times_body (S n))) (fun (m:nat) => plus m (times n m))) ((eq_times_body_S) (n)).
Definition plus_O_n : forall (n:nat), logic.eq (nat) n (plus O n) := fun (n:nat) => (((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) n (y n))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) n (y n))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) n (y n))) (((logic.refl) (nat)) (n)))).
Definition plus_n_O : forall (n:nat), logic.eq (nat) n (plus n O) := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => logic.eq (nat) _x_365 (plus _x_365 O))) ((((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) O (y O))) (((logic.refl) (nat)) (O)))))) (fun (x_366:nat) => fun (_x_368:logic.eq (nat) x_366 (plus x_366 O)) => ((((sym_eq_plus) (S x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S x_366) (y O))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S x_366) (y O))) ((((sym_eq_plus_body_S) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S x_366) (y O))) (((((((logic.rewrite_l) (nat)) (x_366)) (fun (__:nat) => logic.eq (nat) (S x_366) (S __))) (((logic.refl) (nat)) (S x_366))) (plus x_366 O)) (_x_368))))))) (n).
Definition plus_n_Sm : forall (n:nat), forall (m:nat), logic.eq (nat) (S (plus n m)) (plus n (S m)) := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (m:nat), logic.eq (nat) (S (plus _x_365 m)) (plus _x_365 (S m)))) (fun (m:nat) => (((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus O (S m)))) ((((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body O m)) (y (S m)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body O m)) (y (S m)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body O (S m)))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body O (S m)))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) (S m) (y (S m)))) (((logic.refl) (nat)) (S m))))))))) (fun (x_366:nat) => fun (_x_368:forall (m:nat), logic.eq (nat) (S (plus x_366 m)) (plus x_366 (S m))) => (fun (m:nat) => (((sym_eq_plus) (S x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus (S x_366) (S m)))) ((((sym_eq_plus) (S x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body (S x_366) m)) (y (S m)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (filter_nat_type (nat -> nat) plus_body (S x_366) m)) (y (S m)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body (S x_366) (S m)))) ((((sym_eq_plus_body_S) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (y m)) (plus_body (S x_366) (S m)))) ((((sym_eq_plus_body_S) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (S (plus x_366 m))) (y (S m)))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S m))) (fun (__:nat) => logic.eq (nat) (S __) (S (plus x_366 (S m))))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S (S m)))) (fun (__:nat) => logic.eq (nat) __ (S (plus x_366 (S m))))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S (S m)))) (fun (__:nat) => logic.eq (nat) (plus x_366 (S (S m))) __)) (((logic.refl) (nat)) (plus x_366 (S (S m))))) (S (plus x_366 (S m)))) ((_x_368) (S m)))) (S (plus x_366 (S m)))) ((_x_368) (S m)))) (S (plus x_366 m))) ((_x_368) (m))))))))))) (n).
Definition commutative_plus : relations.commutative (nat) plus := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (y:nat), logic.eq (nat) (plus _x_365 y) (plus y _x_365))) (fun (y:nat) => (((sym_eq_plus) (O)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y O))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y O))) (((sym_eq_plus_body_O) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y O))) (((((((logic.rewrite_l) (nat)) (y)) (fun (__:nat) => logic.eq (nat) y __)) (((logic.refl) (nat)) (y))) (plus y O)) ((plus_n_O) (y))))))) (fun (x_366:nat) => fun (_x_368:forall (y:nat), logic.eq (nat) (plus x_366 y) (plus y x_366)) => (fun (y:nat) => (((sym_eq_plus) (S x_366)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y (S x_366)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y (S x_366)))) ((((sym_eq_plus_body_S) (x_366)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (plus y (S x_366)))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S y))) (fun (__:nat) => logic.eq (nat) __ (plus y (S x_366)))) (((((((logic.rewrite_r) (nat)) (plus y (S x_366))) (fun (__:nat) => logic.eq (nat) __ (plus y (S x_366)))) (((logic.refl) (nat)) (plus y (S x_366)))) (plus x_366 (S y))) (((((((logic.rewrite_l) (nat)) (S (plus x_366 y))) (fun (__:nat) => logic.eq (nat) __ (plus y (S x_366)))) (((((((logic.rewrite_r) (nat)) (plus y x_366)) (fun (__:nat) => logic.eq (nat) (S __) (plus y (S x_366)))) (((plus_n_Sm) (y)) (x_366))) (plus x_366 y)) ((_x_368) (y)))) (plus x_366 (S y))) (((plus_n_Sm) (x_366)) (y))))) (S (plus x_366 y))) (((plus_n_Sm) (x_366)) (y)))))))) (n).
Definition associative_plus : relations.associative (nat) plus := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (y:nat), forall (z:nat), logic.eq (nat) (plus (plus _x_365 y) z) (plus _x_365 (plus y z)))) (fun (y:nat) => fun (z:nat) => (((sym_eq_plus) (O)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus O y) z) (x (plus y z)))) ((((sym_eq_plus) (O)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (filter_nat_type (nat -> nat) plus_body O (plus y z)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (filter_nat_type (nat -> nat) plus_body O (plus y z)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus_body O y) z) (x (plus y z)))) (((sym_eq_plus_body_O) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus_body O y) z) (x (plus y z)))) (((sym_eq_plus_body_O) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (plus y z))) (((logic.refl) (nat)) (plus y z))))))))) (fun (x_366:nat) => fun (_x_368:forall (y:nat), forall (z:nat), logic.eq (nat) (plus (plus x_366 y) z) (plus x_366 (plus y z))) => (fun (y:nat) => fun (z:nat) => (((sym_eq_plus) (S x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus (S x_366) y) z) (x (plus y z)))) ((((sym_eq_plus) (S x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (filter_nat_type (nat -> nat) plus_body (S x_366) (plus y z)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (filter_nat_type (nat -> nat) plus_body (S x_366) (plus y z)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus_body (S x_366) y) z) (x (plus y z)))) ((((sym_eq_plus_body_S) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (plus_body (S x_366) y) z) (x (plus y z)))) ((((sym_eq_plus_body_S) (x_366)) (fun (x:(nat -> nat)) => logic.eq (nat) (plus (x y) z) (S (plus x_366 (plus y z))))) ((((sym_eq_plus) (S (plus x_366 y))) (fun (x:(nat -> nat)) => logic.eq (nat) (x z) (S (plus x_366 (plus y z))))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (plus x_366 y)) (fun (x:(nat -> nat)) => logic.eq (nat) (x z) (S (plus x_366 (plus y z))))) ((((sym_eq_plus_body_S) (plus x_366 y)) (fun (x:(nat -> nat)) => logic.eq (nat) (x z) (S (plus x_366 (plus y z))))) (((((((logic.rewrite_r) (nat)) (plus x_366 (plus y z))) (fun (__:nat) => logic.eq (nat) (S __) (S (plus x_366 (plus y z))))) (((logic.refl) (nat)) (S (plus x_366 (plus y z))))) (plus (plus x_366 y) z)) (((_x_368) (y)) (z)))))))))))))) (n).
Definition assoc_plus1 : forall (a:nat), forall (b:nat), forall (c:nat), logic.eq (nat) (plus c (plus b a)) (plus (plus b c) a) := fun (a:nat) => fun (b:nat) => fun (c:nat) => ((((((logic.rewrite_r) (nat)) (plus a b)) (fun (__:nat) => logic.eq (nat) (plus c __) (plus (plus b c) a))) (((((((logic.rewrite_r) (nat)) (plus a (plus b c))) (fun (__:nat) => logic.eq (nat) (plus c (plus a b)) __)) (((((((logic.rewrite_r) (nat)) (plus a (plus b c))) (fun (__:nat) => logic.eq (nat) __ (plus a (plus b c)))) (((logic.refl) (nat)) (plus a (plus b c)))) (plus c (plus a b))) (((((((logic.rewrite_l) (nat)) (plus (plus a b) c)) (fun (__:nat) => logic.eq (nat) (plus c (plus a b)) __)) (((commutative_plus) (c)) (plus a b))) (plus a (plus b c))) ((((associative_plus) (a)) (b)) (c))))) (plus (plus b c) a)) (((commutative_plus) (plus b c)) (a)))) (plus b a)) (((commutative_plus) (b)) (a)).
Definition times_Sn_m : forall (n:nat), forall (m:nat), logic.eq (nat) (plus m (times n m)) (times (S n) m) := fun (n:nat) => fun (m:nat) => (((sym_eq_times) (S n)) (fun (y:(nat -> nat)) => logic.eq (nat) (plus m (times n m)) (y m))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (times_body)) (n)) (fun (y:(nat -> nat)) => logic.eq (nat) (plus m (times n m)) (y m))) ((((sym_eq_times_body_S) (n)) (fun (y:(nat -> nat)) => logic.eq (nat) (plus m (times n m)) (y m))) (((logic.refl) (nat)) (plus m (times n m))))).
Definition times_O_n : forall (n:nat), logic.eq (nat) O (times O n) := fun (n:nat) => (((sym_eq_times) (O)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y n))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (times_body)) (fun (y:(nat -> nat)) => logic.eq (nat) O (y n))) (((sym_eq_times_body_O) (fun (y:(nat -> nat)) => logic.eq (nat) O (y n))) (((logic.refl) (nat)) (O)))).
Definition times_n_O : forall (n:nat), logic.eq (nat) O (times n O) := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => logic.eq (nat) O (times _x_365 O))) (((((((logic.rewrite_l) (nat)) (O)) (fun (__:nat) => logic.eq (nat) O __)) (((logic.refl) (nat)) (O))) (times O O)) ((times_O_n) (O)))) (fun (x_366:nat) => fun (_x_368:logic.eq (nat) O (times x_366 O)) => (((((((logic.rewrite_l) (nat)) (plus O (times x_366 O))) (fun (__:nat) => logic.eq (nat) O __)) (((((((logic.rewrite_l) (nat)) (O)) (fun (__:nat) => logic.eq (nat) O (plus O __))) (((((((logic.rewrite_l) (nat)) (O)) (fun (__:nat) => logic.eq (nat) O __)) (((logic.refl) (nat)) (O))) (plus O O)) ((plus_O_n) (O)))) (times x_366 O)) (_x_368))) (times (S x_366) O)) (((times_Sn_m) (x_366)) (O))))) (n).
Definition times_n_Sm : forall (n:nat), forall (m:nat), logic.eq (nat) (plus n (times n m)) (times n (S m)) := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (m:nat), logic.eq (nat) (plus _x_365 (times _x_365 m)) (times _x_365 (S m)))) ((((sym_eq_times) (O)) (fun (y:(nat -> nat)) => forall (m:nat), logic.eq (nat) (plus O (times O m)) (y (S m)))) ((((sym_eq_times) (O)) (fun (y:(nat -> nat)) => forall (m:nat), logic.eq (nat) (plus O (y m)) (filter_nat_type (nat -> nat) times_body O (S m)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (times_body)) (fun (y:(nat -> nat)) => forall (m:nat), logic.eq (nat) (plus O (y m)) (filter_nat_type (nat -> nat) times_body O (S m)))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (times_body)) (fun (y:(nat -> nat)) => forall (m:nat), logic.eq (nat) (plus O (times_body O m)) (y (S m)))) (((sym_eq_times_body_O) (fun (y:(nat -> nat)) => forall (m:nat), logic.eq (nat) (plus O (times_body O m)) (y (S m)))) (((sym_eq_times_body_O) (fun (y:(nat -> nat)) => forall (m:nat), logic.eq (nat) (plus O (y m)) O)) ((((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => forall (m:nat), logic.eq (nat) (y O) O)) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => forall (m:nat), logic.eq (nat) (y O) O)) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => forall (m:nat), logic.eq (nat) (y O) O)) (fun (_m:nat) => ((logic.refl) (nat)) (O)))))))))))) (fun (x_366:nat) => fun (_x_368:forall (m:nat), logic.eq (nat) (plus x_366 (times x_366 m)) (times x_366 (S m))) => (fun (m:nat) => (((sym_eq_times) (S x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (plus (S x_366) (times (S x_366) m)) (y (S m)))) ((((sym_eq_times) (S x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (plus (S x_366) (y m)) (filter_nat_type (nat -> nat) times_body (S x_366) (S m)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (times_body)) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (plus (S x_366) (y m)) (filter_nat_type (nat -> nat) times_body (S x_366) (S m)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (times_body)) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (plus (S x_366) (times_body (S x_366) m)) (y (S m)))) ((((sym_eq_times_body_S) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (plus (S x_366) (times_body (S x_366) m)) (y (S m)))) ((((sym_eq_times_body_S) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (plus (S x_366) (y m)) (plus (S m) (times x_366 (S m))))) ((((sym_eq_plus) (S x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (y (plus m (times x_366 m))) (plus (S m) (times x_366 (S m))))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (y (plus m (times x_366 m))) (plus (S m) (times x_366 (S m))))) ((((sym_eq_plus_body_S) (x_366)) (fun (y:(nat -> nat)) => logic.eq (nat) (y (plus m (times x_366 m))) (plus (S m) (times x_366 (S m))))) ((((sym_eq_plus) (S m)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (plus x_366 (plus m (times x_366 m)))) (y (times x_366 (S m))))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (m)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (plus x_366 (plus m (times x_366 m)))) (y (times x_366 (S m))))) ((((sym_eq_plus_body_S) (m)) (fun (y:(nat -> nat)) => logic.eq (nat) (S (plus x_366 (plus m (times x_366 m)))) (y (times x_366 (S m))))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S (plus m (times x_366 m))))) (fun (__:nat) => logic.eq (nat) __ (S (plus m (times x_366 (S m)))))) (((((((logic.rewrite_r) (nat)) (plus m (S (times x_366 m)))) (fun (__:nat) => logic.eq (nat) (plus x_366 __) (S (plus m (times x_366 (S m)))))) (((((((logic.rewrite_l) (nat)) (plus x_366 (times x_366 m))) (fun (__:nat) => logic.eq (nat) (plus x_366 (plus m (S (times x_366 m)))) (S (plus m __)))) (((((((logic.rewrite_r) (nat)) (plus x_366 (plus m (times x_366 m)))) (fun (__:nat) => logic.eq (nat) (plus x_366 (plus m (S (times x_366 m)))) (S __))) (((((((logic.rewrite_r) (nat)) (plus x_366 (S (plus m (times x_366 m))))) (fun (__:nat) => logic.eq (nat) (plus x_366 (plus m (S (times x_366 m)))) __)) (((((((logic.rewrite_r) (nat)) (plus m (S (times x_366 m)))) (fun (__:nat) => logic.eq (nat) (plus x_366 (plus m (S (times x_366 m)))) (plus x_366 __))) (((logic.refl) (nat)) (plus x_366 (plus m (S (times x_366 m)))))) (S (plus m (times x_366 m)))) (((plus_n_Sm) (m)) (times x_366 m)))) (S (plus x_366 (plus m (times x_366 m))))) (((plus_n_Sm) (x_366)) (plus m (times x_366 m))))) (plus m (plus x_366 (times x_366 m)))) (((((((logic.rewrite_l) (nat)) (plus (plus x_366 m) (times x_366 m))) (fun (__:nat) => logic.eq (nat) (plus m (plus x_366 (times x_366 m))) __)) ((((assoc_plus1) (times x_366 m)) (x_366)) (m))) (plus x_366 (plus m (times x_366 m)))) ((((associative_plus) (x_366)) (m)) (times x_366 m))))) (times x_366 (S m))) ((_x_368) (m)))) (S (plus m (times x_366 m)))) (((plus_n_Sm) (m)) (times x_366 m)))) (S (plus x_366 (plus m (times x_366 m))))) (((plus_n_Sm) (x_366)) (plus m (times x_366 m)))))))))))))))))) (n).
Definition commutative_times : relations.commutative (nat) times := fun (n:nat) => ((((nat_ind) (fun (_x_365:nat) => forall (y:nat), logic.eq (nat) (times _x_365 y) (times y _x_365))) ((((sym_eq_times) (O)) (fun (y:(nat -> nat)) => forall (z:nat), logic.eq (nat) (y z) (times z O))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (times_body)) (fun (y:(nat -> nat)) => forall (z:nat), logic.eq (nat) (y z) (times z O))) (((sym_eq_times_body_O) (fun (y:(nat -> nat)) => forall (z:nat), logic.eq (nat) (y z) (times z O))) (fun (y:nat) => ((((((logic.rewrite_l) (nat)) (O)) (fun (__:nat) => logic.eq (nat) O __)) (((logic.refl) (nat)) (O))) (times y O)) ((times_n_O) (y))))))) (fun (x_366:nat) => fun (_x_368:forall (y:nat), logic.eq (nat) (times x_366 y) (times y x_366)) => (fun (y:nat) => (((sym_eq_times) (S x_366)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (times y (S x_366)))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (times_body)) (x_366)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (times y (S x_366)))) ((((sym_eq_times_body_S) (x_366)) (fun (z:(nat -> nat)) => logic.eq (nat) (z y) (times y (S x_366)))) (((((((logic.rewrite_l) (nat)) (plus y (times y x_366))) (fun (__:nat) => logic.eq (nat) (plus y (times x_366 y)) __)) (((((((logic.rewrite_l) (nat)) (times x_366 y)) (fun (__:nat) => logic.eq (nat) (plus y (times x_366 y)) (plus y __))) (((logic.refl) (nat)) (plus y (times x_366 y)))) (times y x_366)) ((_x_368) (y)))) (times y (S x_366))) (((times_n_Sm) (y)) (x_366)))))))) (n).
Definition le_S_S : forall (n:nat), forall (m:nat), (le n m) -> le (S n) (S m) := fun (n:nat) => fun (m:nat) => fun (lenm:le n m) => (((((((le_ind) (n)) (fun (x_417:nat) => le (S n) (S x_417))) ((le_n) (S n))) (fun (m0:nat) => fun (_x_419:le n m0) => (fun (_x_421:le (S n) (S m0)) => ((((le_S) (S n)) (S m0)) (_x_421))))) (m)) (lenm)).
Definition le_O_n : forall (n:nat), le O n := fun (n:nat) => ((((nat_ind) (le O)) ((le_n) (O))) (fun (x_366:nat) => fun (_x_368:le O x_366) => ((((le_S) (O)) (x_366)) (_x_368)))) (n).
Definition transitive_le : relations.transitive (nat) le := fun (a:nat) => fun (b:nat) => fun (c:nat) => fun (leab:le a b) => (fun (lebc:le b c) => (((((((le_ind) (b)) (fun (x_417:nat) => le a x_417)) (leab)) (fun (m:nat) => fun (_x_419:le b m) => (fun (_x_421:le a m) => ((((le_S) (a)) (m)) (_x_421))))) (c)) (lebc))).
Definition monotonic_le_plus_r : forall (n:nat), relations.monotonic (nat) le (fun (m:nat) => plus n m) := fun (n:nat) => fun (a:nat) => fun (b:nat) => ((((nat_ind) (fun (_x_365:nat) => (le a b) -> le (plus _x_365 a) (plus _x_365 b))) ((((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => (le a b) -> le (plus O a) (y b))) ((((sym_eq_plus) (O)) (fun (y:(nat -> nat)) => (le a b) -> le (y a) (filter_nat_type (nat -> nat) plus_body O b))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => (le a b) -> le (y a) (filter_nat_type (nat -> nat) plus_body O b))) (((((sym_eq_filter_nat_type_O) (nat -> nat)) (plus_body)) (fun (y:(nat -> nat)) => (le a b) -> le (plus_body O a) (y b))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => (le a b) -> le (plus_body O a) (y b))) (((sym_eq_plus_body_O) (fun (y:(nat -> nat)) => (le a b) -> le (y a) b)) (fun (auto:le a b) => (auto))))))))) (fun (m:nat) => fun (H:(le a b) -> le (plus m a) (plus m b)) => (fun (leab:le a b) => ((((sym_eq_plus) (S m)) (fun (y:(nat -> nat)) => le (plus (S m) a) (y b))) ((((sym_eq_plus) (S m)) (fun (y:(nat -> nat)) => le (y a) (filter_nat_type (nat -> nat) plus_body (S m) b))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (m)) (fun (y:(nat -> nat)) => le (y a) (filter_nat_type (nat -> nat) plus_body (S m) b))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) (plus_body)) (m)) (fun (y:(nat -> nat)) => le (plus_body (S m) a) (y b))) ((((sym_eq_plus_body_S) (m)) (fun (y:(nat -> nat)) => le (plus_body (S m) a) (y b))) ((((sym_eq_plus_body_S) (m)) (fun (y:(nat -> nat)) => le (y a) (S (plus m b)))) ((((le_S_S) (plus m a)) (plus m b)) ((H) (leab)))))))))))) (n).
Definition monotonic_le_plus_l : forall (m:nat), relations.monotonic (nat) le (fun (n:nat) => plus n m) := fun (m:nat) => fun (x:nat) => fun (y:nat) => fun (auto:le x y) => (((((logic.eq_coerc) (le (plus m x) (plus m y))) (le (plus x m) (plus y m))) (((((monotonic_le_plus_r) (m)) (x)) (y)) (auto))) (((((((logic.rewrite_r) (nat)) (plus m x)) (fun (__:nat) => logic.eq (Prop) (le (plus m x) (plus m y)) (le __ (plus y m)))) (((((((logic.rewrite_r) (nat)) (plus m y)) (fun (__:nat) => logic.eq (Prop) (le (plus m x) (plus m y)) (le (plus m x) __))) (((logic.refl) (Prop)) (le (plus m x) (plus m y)))) (plus y m)) (((commutative_plus) (y)) (m)))) (plus x m)) (((commutative_plus) (x)) (m)))).
Definition le_plus_n : forall (n:nat), forall (m:nat), le m (plus n m) := fun (n:nat) => fun (m:nat) => ((((logic.eq_coerc) (le (plus O m) (plus n m))) (le m (plus n m))) (((((monotonic_le_plus_l) (m)) (O)) (n)) ((le_O_n) (n)))) (((((((logic.rewrite_l) (nat)) (m)) (fun (__:nat) => logic.eq (Prop) (le __ (plus n m)) (le m (plus n m)))) (((logic.refl) (Prop)) (le m (plus n m)))) (plus O m)) ((plus_O_n) (m))).
Definition le_plus_n_r : forall (n:nat), forall (m:nat), le m (plus m n) := fun (n:nat) => fun (m:nat) => ((((logic.eq_coerc) (le m (plus n m))) (le m (plus m n))) (((le_plus_n) (n)) (m))) (((((((logic.rewrite_r) (nat)) (plus n m)) (fun (__:nat) => logic.eq (Prop) (le m (plus n m)) (le m __))) (((logic.refl) (Prop)) (le m (plus n m)))) (plus m n)) (((commutative_plus) (m)) (n))).
Definition monotonic_lt_plus_l : forall (n:nat), relations.monotonic (nat) lt (fun (m:nat) => plus m n) := fun (n:nat) => fun (x:nat) => fun (y:nat) => fun (auto:lt x y) => (((((logic.eq_coerc) (le (plus n (S x)) (plus n y))) (le (S (plus x n)) (plus y n))) (((((monotonic_le_plus_r) (n)) (S x)) (y)) (auto))) (((((((logic.rewrite_r) (nat)) (plus n x)) (fun (__:nat) => logic.eq (Prop) (le (plus n (S x)) (plus n y)) (le (S __) (plus y n)))) (((((((logic.rewrite_r) (nat)) (plus n (S x))) (fun (__:nat) => logic.eq (Prop) (le (plus n (S x)) (plus n y)) (le __ (plus y n)))) (((((((logic.rewrite_r) (nat)) (plus n y)) (fun (__:nat) => logic.eq (Prop) (le (plus n (S x)) (plus n y)) (le (plus n (S x)) __))) (((logic.refl) (Prop)) (le (plus n (S x)) (plus n y)))) (plus y n)) (((commutative_plus) (y)) (n)))) (S (plus n x))) (((plus_n_Sm) (n)) (x)))) (plus x n)) (((commutative_plus) (x)) (n)))).
Definition monotonic_lt_times_r : forall (c:nat), (lt O c) -> relations.monotonic (nat) lt (fun (t:nat) => times c t) := fun (c:nat) => fun (posc:lt O c) => (fun (n:nat) => fun (m:nat) => fun (ltnm:lt n m) => (((((((le_ind) (S n)) (fun (x_417:nat) => lt (times c n) (times c x_417))) (((((logic.eq_coerc) (le (S (plus O (times c n))) (plus c (times c n)))) (le (S (times c n)) (times c (S n)))) (((((monotonic_lt_plus_l) (times c n)) (O)) (c)) (posc))) (((((((logic.rewrite_r) (nat)) (plus O (S (times c n)))) (fun (__:nat) => logic.eq (Prop) (le __ (plus c (times c n))) (le (S (times c n)) (times c (S n))))) (((((((logic.rewrite_l) (nat)) (plus c (times c n))) (fun (__:nat) => logic.eq (Prop) (le (plus O (S (times c n))) (plus c (times c n))) (le (S (times c n)) __))) (((((((logic.rewrite_l) (nat)) (S (times c n))) (fun (__:nat) => logic.eq (Prop) (le __ (plus c (times c n))) (le (S (times c n)) (plus c (times c n))))) (((logic.refl) (Prop)) (le (S (times c n)) (plus c (times c n))))) (plus O (S (times c n)))) ((plus_O_n) (S (times c n))))) (times c (S n))) (((times_n_Sm) (c)) (n)))) (S (plus O (times c n)))) (((plus_n_Sm) (O)) (times c n))))) (fun (a:nat) => fun (__:le (S n) a) => (fun (lt1:le (S (times c n)) (times c a)) => ((((((transitive_le) (S (times c n))) (times c a)) (times c (S a))) (lt1)) (((((logic.eq_coerc) (le (times c a) (plus (times c a) c))) (le (times c a) (times c (S a)))) (((le_plus_n_r) (c)) (times c a))) (((((((logic.rewrite_l) (nat)) (plus c (times c a))) (fun (__1:nat) => logic.eq (Prop) (le (times c a) (plus (times c a) c)) (le (times c a) __1))) (((((((logic.rewrite_r) (nat)) (plus c (times c a))) (fun (__1:nat) => logic.eq (Prop) (le (times c a) __1) (le (times c a) (plus c (times c a))))) (((logic.refl) (Prop)) (le (times c a) (plus c (times c a))))) (plus (times c a) c)) (((commutative_plus) (times c a)) (c)))) (times c (S a))) (((times_n_Sm) (c)) (a)))))))) (m)) (ltnm))).
Definition monotonic_lt_times_l : forall (c:nat), (lt O c) -> relations.monotonic (nat) lt (fun (t:nat) => times t c) := fun (c:nat) => fun (auto:lt O c) => (fun (x:nat) => fun (y:nat) => fun (auto':lt x y) => (((((logic.eq_coerc) (le (S (times c x)) (times c y))) (le (S (times x c)) (times y c))) ((((((monotonic_lt_times_r) (c)) (auto)) (x)) (y)) (auto'))) (((((((logic.rewrite_r) (nat)) (times c x)) (fun (__:nat) => logic.eq (Prop) (le (S (times c x)) (times c y)) (le (S __) (times y c)))) (((((((logic.rewrite_r) (nat)) (times c y)) (fun (__:nat) => logic.eq (Prop) (le (S (times c x)) (times c y)) (le (S (times c x)) __))) (((logic.refl) (Prop)) (le (S (times c x)) (times c y)))) (times y c)) (((commutative_times) (y)) (c)))) (times x c)) (((commutative_times) (x)) (c))))).
